/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.benutzerverwaltung.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class BenutzerTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final String benutzerkennung;
    public String getBenutzerkennung(){
      return benutzerkennung;
    }

  public BenutzerTK(
String benutzerkennung
  ) {
    super();


      this.benutzerkennung = benutzerkennung;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((benutzerkennung == null) ? 0 : benutzerkennung.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof BenutzerTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        BenutzerTK other = (BenutzerTK) obj;

                if (benutzerkennung == null) {
          if (other.benutzerkennung != null) {
            return false;
          }
        } else if (!benutzerkennung.equals(other.benutzerkennung)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return BenutzerConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(BenutzerConstants.MESSAGE_KEY_ENTITY_EINZAHL, BenutzerConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, benutzerkennung));
        
        return result;
      }


            @Override
            public String toString() {
            return "BenutzerTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"benutzerkennung="+benutzerkennung
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(BenutzerConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL) + "=" + benutzerkennung
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Benutzer> java.util.Map<BenutzerTK, E> mappeBenutzerNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Benutzer::getBenutzerTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Benutzer, BenutzerTK> getBenutzerToTKFunction() {
                return Benutzer::getBenutzerTK;
                }

}
